
// Usage: Place this into scripts/Polygonobj folder. restart Cheetah3D, then select from Tools -> Scritp -> Polygon Script
//

// notice that this extends the functionality of the class array
// !ANY! new Array will be able to use this function
if( !Array.indexOf) {
	Array.prototype.indexOf = function(str) {
		for(var i = 0; i < this.length; i++) {
			if(this[i] == str)
				return i;
		}
		return -1;
	}
	//print("Array extended");
}

// note that is is an object...
// save the material and the location of the images files
function Images(material,name) {
	this.material = material;
	this.locationOfFiles = "";
	this.my_Files = new Array();
	this.current_Image = 0;
	this.name = "";
	if( name != undefined)
		this.name = name;
	this.nextImage = function(){
		this.current_Image++;
		if( this.current_Image >= this.my_Files.length)
			this.current_Image = 0;
		this.material.setParameter("colorTex",this.my_Files[index],false);
	};
	this.imageAt = function(index) {
		index %= this.my_Files.length;
		this.current_Image = index;
		this.material.setParameter("colorTex",this.my_Files[index],false);
	}
	// load images is misnamed... all it does is scan the given directory
	// to find a series of file names and stores them in an array
	this.loadImages = function(path) {
		var f = new File(path);
		var name = f.lastPathComponent();
		var dir = f.directory();
		this.my_Files[0] = path; // the first one is easy
		// file names are expected to have the following format
		// name of file ####.format
		// just need to parse the file name
		var n = name.split(".");
		var format = n[1]; // get the extention
		n = n[0]; // focus on the name and ####
		var count = "";
		name = "";
		var flag = true;
		for(var i= n.length-1;i>=0;i--) {
			var c = n[i];
			if(flag && c >= "0" && c <= "9")
				count = c + count;
			else {
				name = c + name;
				flag = false;
			}
		}
		var len = count.length; // we need the length to add leading zeros
		count = 1 * count;
		print( "name = \""+name + "\"  count starts at ="+count + "  with ext="+format);
		flag = true;
		count++; // already did this one
		while(flag) {
			var n1 = ""+count;
			while( n1.length < len)
				n1 = "0" + n1;
			n1 = dir + "/" + name + n1 + "." + format;
			f = new File(n1);
			if( f.exist()) {
				print(n1);
				this.my_Files[this.my_Files.length] = n1;
				count++;
			} else
				flag = false;
		}
	}
}

var the_Files = new Array(); // the list of file names
var the_Object = null;

function buildUI(obj){
    the_Object = obj;
	obj.setParameter("name","MatMovie");
	obj.addParameterFloat("time",0,0,200000,true,true); // 
	obj.addParameterButton("Scan for materials","Locate","findMaterials"); // 
//	obj.addParameterButton("Help","Help","displayHelp"); // 
	findMaterials();
}

function findMaterials() {
    var doc = the_Object.document();
	var n = doc.materialCount();
	the_Files = new Array();
	if( n > 0) {
		// no need to scan if there are no materials
		for(var i = 0;i <n;i++) {
			var m = doc.materialAtIndex(i);
			var a = parseIt(m.rib());
			var j = a.indexOf("Surface");
			if(j == -1)
				continue;
			if(a[j+1] == "Material") {
				j = a.indexOf("name");
				if(j == -1)
					continue;
				var name = a[j+1];
				var aa = name.split(".");
				if( aa.length > 1 && aa[1] == "mov")
					the_Files[the_Files.length] = new Images(m,name);
			}
		}
		if( the_Files.length > 0)
			for(i=0;i<the_Files.length;i++) {
				str = "Please loacte the first file of the image sequence for material named "+the_Files[i].name;
				if(OS.messageBox("Information Needed",str)==1) {
					var p = OS.runOpenPanel("jpg","bmp","png"); // add other file types here
					if(p==null)
						continue;
					the_Files[i].loadImages(p);
				}
			}
	//	print("located "+ the_Files.length + " materials.");
	}
	
	
	
}

function buildObject(obj){
	var t = obj.getParameter("time");
	if( the_Files.length > 0) {
		t = Math.floor(t);
		for(i=0;i<the_Files.length;i++) {
			the_Files[i].imageAt(t);
		}
	}
}

function parseIt(str) {
	// given a string of material properties
	// break it into a list of names and values
	var a = new Array();
	
	var i,s = "";
	for( i =0;i<str.length;i++) {
		if(str[i] == " ") {
			a[a.length] = s;
			s = "";
			continue
		}
		if(str[i] == "\"") {
			i++;
			while(str[i] != "\"")
				s = s + str[i++];
			continue;
		}
		if( str[i] == "[") {
			i++;
			while(str[i] != "]")
				s = s + str[i++];
			continue;
		}
		s = s + str[i];
	}
	return a;
}
